# Module `debug`

The Debug Library.

This library provides the functionality of the debug interface to Lua programs. You should exert care when using this library. The functions provided here should be used exclusively for debugging and similar tasks, such as profiling. Please resist the temptation to use them as a usual programming tool: they can be very slow. Moreover, several of these functions violate some assumptions about Lua code (e.g., that variables local to a function cannot be accessed from outside or that userdata metatables cannot be changed by Lua code) and therefore can compromise otherwise secure code.

All functions in this library are provided inside the debug table. All functions that operate over a thread have an optional first argument which is the thread to operate over. The default is always the current thread.

## Type `debug`

debug.debug() | Enters an interactive mode with the user, running each string that the user enters.
debug.getfenv(o) | Returns the environment of object `o`.
debug.gethook(thread) | Returns the current hook settings of the thread, as three values: the current hook function, the current hook mask, and the current hook count (as set by the `debug.sethook` function).
debug.getinfo(thread, func, what) | Returns a table with information about a function.
debug.getlocal(thread, level, local) | This function returns the name and the value of the local variable with index `local` of the function at level `level` of the stack.
debug.getmetatable(object) | Returns the metatable of the given `object` or nil if it does not have a metatable.
debug.getregistry() | Returns the registry table.
debug.getupvalue(func, up) | This function returns the name and the value of the upvalue with index `up` of the function `func`.
debug.setfenv(object, table) | Sets the environment of the given `object` to the given `table`.
debug.sethook(thread, hook, mask, count) | Sets the given function as a hook.
debug.setlocal(thread, level, local, value) | This function assigns the value `value` to the local variable with index `local` of the function at level `level` of the stack.
debug.setmetatable(object, table) | Sets the metatable for the given `object` to the given `table` (which can be nil).
debug.setupvalue(func, up, value) | This function assigns the value `value` to the upvalue with index `up` of the function `func`.

## Type `debug`

### Field(s)

debug.debug()

  Enters an interactive mode with the user, running each string that the user enters.

  Using simple commands and other debug facilities, the user can inspect global and local variables, change their values, evaluate expressions, and so on. A line containing only the word `cont` finishes this function, so that the caller continues its execution.

  Note that commands for `debug.debug` are not lexically nested within any function, and so have no direct access to local variables.

debug.getfenv(o)

  Returns the environment of object `o`.

  ### Parameter

  - `o` : object to handle.

  ### Return value

  #table: the environment of object `o`.

debug.gethook(thread)

  Returns the current hook settings of the thread, as three values: the current hook function, the current hook mask, and the current hook count (as set by the `debug.sethook` function).

  ### Parameter

  - `#thread thread` : thread to handle.

debug.getinfo(thread, func, what)

  Returns a table with information about a function.

  You can give the function directly, or you can give a number as the value of `func`, which means the function running at level `func` of the call stack of the given thread: level 0 is the current function (`getinfo` itself); level 1 is the function that called `getinfo`; and so on. If `function` is a number larger than the number of active functions, then `getinfo` returns nil.

  The returned table can contain all the fields returned by `lua_getinfo`, with the string `what` describing which fields to fill in. The default for `what` is to get all information available, except the table of valid lines. If present, the option '`f`' adds a field named `func` with the function itself. If present, the option '`L`' adds a field named `activelines` with the table of valid lines.

  For instance, the expression `debug.getinfo(1,"n").name` returns a table with a name for the current function, if a reasonable name can be found, and the expression `debug.getinfo(print)` returns a table with all available information about the `print` function.

  ### Parameters

  - `#thread thread` : thread to handle.

  - `func` : the function or a number which means the function running at level `func`.

  - `#string what` : used to precise information returned.

  ### Return value

  #table: with information about the function `func`.

debug.getlocal(thread, level, local)

  This function returns the name and the value of the local variable with index `local` of the function at level `level` of the stack.

  (The first parameter or local variable has index 1, and so on, until the last active local variable.) The function returns nil if there is no local variable with the given index, and raises an error when called with a `level` out of range. (You can call `debug.getinfo` to check whether the level is valid.)

  Variable names starting with '`(`' (open parentheses) represent internal variables (loop control variables, temporaries, and C function locals).

  ### Parameters

  - `#thread thread` : thread which owns the local variable.

  - `#number level` : the stack level.

  - `#number local` : the index of the local variable.

  ### Return value

  The name and the value of the local variable with index `local` of the function at level `level` of the stack.

debug.getmetatable(object)

  Returns the metatable of the given `object` or nil if it does not have a metatable.

  ### Parameter

  - `object` : object to handle.

  ### Return value

  #table: the metatable of the given `object` or nil if it does not have a metatable.

debug.getregistry()

  Returns the registry table.

debug.getupvalue(func, up)

  This function returns the name and the value of the upvalue with index `up` of the function `func`.

  The function returns nil if there is no upvalue with the given index.

  ### Parameters

  - `func` : function which owns the upvalue.

  - `#number up` : index of upvalue.

  ### Return value

  The name and the value of the upvalue with index `up` of the function `func`.

debug.setfenv(object, table)

  Sets the environment of the given `object` to the given `table`.

  Returns `object`.

  ### Parameters

  - `object` : object to handle.

  - `#table table` : the environment to set.

  ### Return value

  the given object.

debug.sethook(thread, hook, mask, count)

  Sets the given function as a hook.

  The string `mask` and the number `count` describe when the hook will be called. The string mask may have the following characters, with the given meaning:

  - `"c"`: the hook is called every time Lua calls a function;
  - `"r"`: the hook is called every time Lua returns from a function;
  - `"l"`: the hook is called every time Lua enters a new line of code.

  With a `count` different from zero, the hook is called after every `count` instructions.

  When called without arguments, `debug.sethook` turns off the hook.

  When the hook is called, its first parameter is a string describing the event that has triggered its call: `"call"`, `"return"` (or `"tail return"`, when simulating a return from a tail call),`"line"`, and `"count"`. For line events, the hook also gets the new line number as its second parameter. Inside a hook, you can call `getinfo` with level 2 to get more information about the running function (level 0 is the `getinfo` function, and level 1 is the hook function), unless the event is `"tail return"`. In this case, Lua is only simulating the return, and a call to `getinfo` will return invalid data.

  ### Parameters

  - `#thread thread` : thread on which the hook is set.

  - `hook` : a function which takes two argument : event as string and line number.

  - `#string mask` : could be `"c"`, `"r"` or `"l"`.

  - `#number count` : the hook is called after every `count` instructions.

debug.setlocal(thread, level, local, value)

  This function assigns the value `value` to the local variable with index `local` of the function at level `level` of the stack.

  The function returns nil if there is no local variable with the given index, and raises an error when called with a `level` out of range. (You can call `getinfo` to check whether the level is valid.) Otherwise, it returns the name of the local variable.

  ### Parameters

  - `#thread thread` : thread which owns the local variable.

  - `#number level` : the stack level.

  - `#number local` : the index of the local variable.

  - `value` : the new value.

  ### Return values

  1. #string: the name of the variable if it succeed.

  2. #nil: if there no local variable with the given index.

debug.setmetatable(object, table)

  Sets the metatable for the given `object` to the given `table` (which can be nil).

  ### Parameters

  - `object` : object to handle.

  - `#table table` : the metatable for `object`.

debug.setupvalue(func, up, value)

  This function assigns the value `value` to the upvalue with index `up` of the function `func`.

  The function returns nil if there is no upvalue with the given index. Otherwise, it returns the name of the upvalue.

  ### Parameters

  - `func` : function which owns the upvalue.

  - `up` : index of the upvalue.

  - `value` : the new value.

  ### Return values

  1. #string: the name of the upvalue if it succeed.

  2. #nil: if there no upvalue with the given index.